function C=horzcat(varargin)
  assert( nargin>=2 )
  [N,nr,nc]=find_amatsize(varargin{:});
  A=cell(1,nargin);
  for i=1:nargin
    if isamat(varargin{i})
      assert(varargin{i}.N == N && varargin{i}.nr == nr)
      A{i}=varargin{i}.values;
    else
      assert( size(varargin{i},1) == nr )
      tmp=amat(N,varargin{i});
      A{i}=tmp.values;
    end
  end
  C=amat(cat(3,A{:}));
end

function [N,nr,nc]=find_amatsize(varargin)
  for i=1:nargin
    if isamat(varargin{i})
      [N,nr,nc]=size(varargin{i});
      return
    end
  end
end
