function S=gitinfo()
% FUNCTION fc_amat.gitinfo(): returns some informations on the package/toolbox.
%
%    Copyright (C) 2018-2020 F. Cuvelier
%
  S=struct('name','fc-amat', 'tag','0.1.1','commit','ab639dd1d3be0ed76a8df9a9b637400ad797f32a','date', '2020-01-02','time','06-40-28','status',0);return; % automatically updated
  rep=fc_amat.path();
  if fc_tools.git.isrepository(rep)
    S=struct('name',  fc_tools.git.get_name(rep), ...
             'tag',   fc_tools.git.get_tag(rep), ...
             'commit',fc_tools.git.get_commit(rep), ...
             'date',  fc_tools.git.get_date(rep), ...
             'time',  fc_tools.git.get_time(rep), ...
             'status',fc_tools.git.isup2date(rep));
  else
    tag='';
    commit='';
    strdate='';
    strtime='';
    S=struct('name','fc-amat','tag',tag,'commit',commit,'date',strdate,'time',strtime,'status',-1);
  end
end
