fc_tools.utils.cleaning()
N=10;
options={'perm',@(A) colamd(A)};
[bvp,info]=fc_vfemp1.examples.setBVPfunny2D01(N,2);
fc_vfemp1.examples.print_info(info)

fprintf('*** Solving %s\n',info.name)
[U,SolveInfo]=bvp.solve('split',true,'time',true,options{:});
fprintf('    -> ndof (number of degrees of freedom) = %d\n',sum(cellfun(@(x) size(x,1),U)));
fc_vfemp1.examples.print_info(SolveInfo)

if fc_tools.utils.is_fcPackage('siplt')
  fprintf('*** Graphics with fc_siplt package\n');
  tstart=tic();
  Th=bvp.Th;
  figure(1)
  Th.plot(U{1})
  axis image;axis off;shading interp
  colorbar
  figure(2);
  Th.plot(U{2})
  axis image;axis off;shading interp         
  colorbar 
  tcpu=toc(tstart);
  fprintf('    -> Done in %.3f(s)\n',tcpu)
  fc_tools.graphics.monitors.autoGrid()
end
